'*****************************************************
'* Boxes 1.0 *
'* *
'* Based on Smashout for Ibasic *
'* *
'* By Jim Klutho *
'* *
'* Released to Public Domain *
'*****************************************************
#Compile Exe
#Dim All
#Include "WIN32API.INC"
'*****************************************************
'* User Defined Types *
'*****************************************************
Type BallType
X As Long ' X Axis of the Ball
Y As Long ' Y Axis of the Ball
Radius As Long
XVelocity As Long ' X Axis Velocity of the Ball
YVelocity As Long ' Y Axis Velocity of the Ball
End Type
Type SpriteType
BackGround As Dword ' Background Bitmap Handle
theRect As RECT
isVisible As Long
End Type

Type PaddleType
X As Long
XVelocity As Long
r As RECT
End Type
'*****************************************************
'* Global Variables *
'*****************************************************
Global hDlg As Dword
Global BoxWidth As Dword
Global BoxHeight As Dword
Global xg As Long
Global yg As Long
Global s() As SpriteType
Global b As BallType
Global p As PaddleType
Global lpx As Long
Global lpy As Long
Global New_Timer As Dword
Global OldGraphicProc As Dword
Global hGraphic As Dword
Global usingMouse As Long
Global BallMoving As Long
Global BoxCount As Long
Global BallCount As Long
'*****************************************************
'* Control Identifiers *
'*****************************************************
%IDC_GAMEWIN = 130

'*****************************************************
'* Constants *
'*****************************************************
%NUMCOLS = 16
%NUMROWS = 10
%PADDLEWIDTH = 70
%PADDLEHEIGHT = 14
%PADDLEOFFSET = 30
'*****************************************************
'* Subs and Functions *
'*****************************************************
Sub CheckCollisions
Local balltop As POINTAPI
Local ballleft As POINTAPI
Local ballbottom As POINTAPI
Local ballright As POINTAPI
Local x As Long
Local y As Long
'calc ball collision points
balltop.x=b.x + b.radius\2 : balltop.y=b.y
ballleft.x=b.x : balltop.y=b.y + b.radius\2
ballbottom.x=b.x + b.radius\2 : ballbottom.y=b.y + b.radius
ballright.x=b.x + b.radius : ballright.y=b.y + b.radius\2
'ball and paddle
If PtInRect(p.r,ballbottom.x,ballbottom.y) <> 0 Then
b.YVelocity=-b.YVelocity
End If
'ball and floor
If ballbottom.y > p.r.nBottom + 4 Then
BallMoving=0
End If
'ball and box
For x=1 To %NUMCOLS
For y=1 To %NUMROWS
If PtInRect(s(x,y).therect,balltop.x,balltop.y) <> 0 And s(x,y).isVisible=1 Then
s(x,y).isVisible=0
b.YVelocity=-b.YVelocity
Decr BoxCount
End If
Next y
Next x
End Sub

Sub DrawBoxes
Local count As Long
Local counter As Long
For counter = 1 To %NUMROWS
For count=1 To %NUMCOLS
If s(count,counter).isVisible=1 Then
Graphic Box (s(count,counter).theRect.nLeft, s(count,counter).theRect.nTop) - (s(count,counter).theRect.nRight, s(count,counter).theRect.nBottom), 0, %Black, s(count,counter).BackGround
End If
Next count
Next counter
End Sub
Sub MoveGame
Local sMsg As String
Local myrkey As Long
Local mylkey As Long
Graphic Clear %Black
'move paddle
myrkey=GetAsyncKeyState(%VK_RIGHT) And &H8000
mylkey=GetAsyncKeyState(%VK_LEFT) And &H8000
If myrkey <> 0 Then
p.x=p.x + 15
usingMouse=0
ElseIf mylkey <> 0 Then
p.x=p.x - 15
usingMouse=0
ElseIf usingMouse=1 Then
p.x=lpx 'use the mouse position
End If
p.x=Max&(p.x,2)
p.x=Min&(p.x,xg-%PADDLEWIDTH-5)
p.r.nLeft=p.x : p.r.nRight=p.x+%PADDLEWIDTH : p.r.nTop = yg-%PADDLEOFFSET : p.r.nBottom = yg-%PADDLEOFFSET + %PADDLEHEIGHT
Graphic Box (p.x, yg-%PADDLEOFFSET) - (p.x + %PADDLEWIDTH, yg - %PADDLEOFFSET + %PADDLEHEIGHT), 0, %LtGray, %LtGray
'post time
sMsg = "Boxes remaining = " + Str$(BoxCount)
Graphic Set Pos (20, 5)
Graphic Print sMsg
sMsg = "Balls remaining = " + Str$(BallCount)
Graphic Set Pos (20, 35)
Graphic Print sMsg

'update new ball position
If BallMoving=0 Then
b.x = p.x + %PADDLEWIDTH\2
b.y = yg-%PADDLEOFFSET-12
Graphic Set Pos (20, 420)
Graphic Print "Click Left Button to start ball moving"
Else
b.x=b.x + b.xvelocity
b.y=b.y + b.yvelocity
If b.x > xg-b.radius Or b.x < 0 Then b.xvelocity=-b.xvelocity
If b.y > yg-b.radius Or b.y < 0 Then b.yvelocity=-b.yvelocity
End If
CheckCollisions
'Draw the ball
Graphic Ellipse (b.x, b.y) - (b.x+b.radius, b.y+b.radius), %LtGray, %LtGray
'Draw the boxes
Drawboxes
Graphic ReDraw
End Sub
'*****************************************************
'* Game Window dialog callback procedure *
'*****************************************************
CallBack Function ShowGameProc() As Long
Local count As Long
Local counter As Long
Local x As Long
Local y As Long
Dim mycolors(14) As Long
Local lngResult As Long
Local lpPoint As POINTAPI
Local Result As Long
Local breakflag As Long

Select Case CbMsg
Case %WM_INITDIALOG
lngResult = SetTimer(CbHndl,NEW_TIMER,30,0)
b.x=300
b.y=400
b.radius=12
BoxCount=%NUMROWS * %NUMCOLS
BallCount=3
Graphic Clear %Black
Graphic Color %White,%Black
Graphic Font "Times New Roman", 18, 1
mycolors(1) = RGB(255,0,0): mycolors(2) = RGB(0,255,0) : mycolors(3) = RGB(0,0,255) : mycolors(4) = RGB(255,255,0)
mycolors(5) = RGB(0,255,255) : mycolors(6) = RGB(255,0,255) : mycolors(7) = RGB(255,255,255) : mycolors(8) = RGB(192,0,0)
mycolors(9) = RGB(0,192,0) : mycolors(10) = RGB(0,0,192) : mycolors(11) = RGB(192,192,0): mycolors(12) = RGB(0,192,192)
mycolors(13) = RGB(192,0,192) : mycolors(14) = RGB(192,192,192)
For counter=1 To %NUMROWS
For count= 1 To %NUMCOLS
s(count,counter).BackGround=mycolors(Rnd(1,14))
Next count
Next counter
x=0
y=80
For counter = 1 To %NUMROWS
For count=1 To %NUMCOLS
s(count,counter).isVisible=1
s(count,counter).theRect.nLeft=x
s(count,counter).theRect.nTop=y
s(count,counter).theRect.nRight=x + BoxWidth
s(count,counter).theRect.nBottom=y + BoxHeight
x=x+BoxWidth
Next count
y = y + BoxHeight
x=0
Next counter

OldGraphicProc = SetWindowLong(hGraphic, %GWL_WNDPROC, CodePtr(GraphicProc))
Case %WM_DESTROY
KillTimer(CbHndl,NEW_TIMER)
If OldGraphicProc Then
SetWindowLong hGraphic, %GWL_WNDPROC, OldGraphicProc
End If
Case %WM_TIMER
Result=GetCursorPos (lpPoint)
Result=ScreenToClient (hDlg,lpPoint)
lpx=lpPoint.x
lpy=lpPoint.y
MoveGame
breakflag=GetAsyncKeyState(%VK_ESCAPE) And &H8000
If breakflag <> 0 Then
Dialog End CbHndl,1
End If
Case %WM_COMMAND
Select Case As Long CbCtl
Case %IDC_GAMEWIN
' Nothing for now
End Select
End Select
End Function
'====================================================================
Function GraphicProc (ByVal hWnd As Dword, ByVal wMsg As Dword, _
ByVal wParam As Dword, ByVal lParam As Long) As Long
'--------------------------------------------------------------------
' Subclass procedure
'------------------------------------------------------------------
Select Case wMsg
Case %WM_CREATE
Case %WM_LBUTTONDOWN
If BallMoving=0 Then
b.xVelocity=-10
b.yVelocity=-10
BallMoving=1
Decr BallCount
End If
Case %WM_MOUSEMOVE
usingMouse=1
Case %WM_LBUTTONUP
Case %WM_KEYDOWN
End Select
Function = CallWindowProc (OldGraphicProc, hWnd, wMsg, wParam, lParam)
End Function
Function ShowGame(Parent As Long) As Long
Local x As Long
Local y As Long
Local I As Long
Local Count As Long
Global lpPoint As POINTAPI
Dim s(%NUMCOLS,%NUMROWS) As spritetype
Local Result As Long
Local hCurClear As Dword
Dim band(31) As Byte
Dim bor(31) As Byte
Local myInstance As Long
x=GetSystemMetrics(%SM_CXSCREEN)
I=x\16
BoxWidth=I-2
BoxHeight=I\3
xg=BoxWidth * 16 + 5
x=xg + 4
y=GetSystemMetrics(%SM_CYSCREEN)-52
yg=y-2
Dialog New Pixels, Parent , "Boxes" ,0,0, x, y, %WS_SYSMENU To hDlg
Control Add Graphic, hdlg, %IDC_GAMEWIN, "", 2, 2, xg, yg ,%WS_CHILD Or %WS_VISIBLE Or %SS_NOTIFY, %WS_EX_CLIENTEDGE
Graphic Attach hDlg, %IDC_GAMEWIN , ReDraw
Control Handle hDlg, %IDC_GAMEWIN To hGraphic
myInstance = GetWindowLong(hDlg,%GWL_HINSTANCE)
For x=0 To 31
band(x)=255
bor(x)=0
Next x
hCurClear=CreateCursor(myInstance,2,2,8,8,band(0),bor(0))
SetClassLong hGraphic, %GCL_HCURSOR, hCurClear
Dialog Show Modal hDlg, Call ShowGameProc
If hCurClear >0 Then DestroyCursor hCurClear

'PlaySound("AppStart.wav", BYVAL myInstance, %SND_FILENAME OR %SND_ASYNC)
End Function
'*****************************************************
'* PBMAIN *
'* *
'* Program Entry Point *
'*****************************************************
Function PBMain () As Long
ShowGame %HWND_DESKTOP
End Function
